My Project: dgVector Class Reference

My Project

Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
dgVector Class Reference

`#include <dgVector.h>`

Inheritance diagram for dgVector:

## Public Member Functions

DG_INLINE | dgVector ()
DG_INLINE | dgVector (const __m128 type)
DG_INLINE | dgVector (const __m128i type)
DG_INLINE | dgVector (const dgFloat32 a)
DG_INLINE | dgVector (const dgFloat32 *const ptr)
DG_INLINE | dgVector (const dgVector &copy)
DG_INLINE | dgVector (const dgBigVector &copy)
DG_INLINE | dgVector (dgFloat32 x, dgFloat32 y, dgFloat32 z, dgFloat32 w)
DG_INLINE | dgVector (dgInt32 ix, dgInt32 iy, dgInt32 iz, dgInt32 iw)
DG_INLINE dgFloat32 | GetScalar () const
DG_INLINE void | Store (dgFloat32 *const dst) const
DG_INLINE dgVector | BroadcastX () const
DG_INLINE dgVector | BroadcastY () const
DG_INLINE dgVector | BroadcastZ () const
DG_INLINE dgVector | BroadcastW () const
DG_INLINE dgVector | Scale3 (dgFloat32 s) const
DG_INLINE dgVector | Scale4 (dgFloat32 s) const
DG_INLINE dgFloat32 & | operator[] (dgInt32 i)
DG_INLINE const dgFloat32 & | operator[] (dgInt32 i) const
DG_INLINE dgVector | operator+ (const dgVector &A) const
DG_INLINE dgVector | operator- (const dgVector &A) const
DG_INLINE dgVector & | operator+= (const dgVector &A)
DG_INLINE dgVector & | operator-= (const dgVector &A)
DG_INLINE dgFloat32 | operator% (const dgVector &A) const
DG_INLINE dgVector | DotProduct4 (const dgVector &A) const
DG_INLINE dgVector | operator* (const dgVector &B) const
DG_INLINE dgVector | CrossProduct4 (const dgVector &A, const dgVector &B) const
DG_INLINE dgVector | CompProduct3 (const dgVector &A) const
DG_INLINE dgVector | Reciproc () const
DG_INLINE dgVector | CompProduct4 (const dgVector &A) const
DG_INLINE dgVector | AddHorizontal () const
DG_INLINE dgVector | Abs () const
dgVector | GetMax (const dgVector &data) const
dgVector | GetMin (const dgVector &data) const
DG_INLINE dgVector | GetInt () const
DG_INLINE dgVector | TestZero () const
DG_INLINE dgVector | Floor () const
DG_INLINE dgVector | Sqrt () const
DG_INLINE dgVector | InvSqrt () const
DG_INLINE dgVector | InvMagSqrt () const
DG_INLINE dgVector | operator> (const dgVector &data) const
DG_INLINE dgVector | operator== (const dgVector &data) const
DG_INLINE dgVector | operator< (const dgVector &data) const
DG_INLINE dgVector | operator>= (const dgVector &data) const
DG_INLINE dgVector | operator<= (const dgVector &data) const
DG_INLINE dgVector | operator & (const dgVector &data) const
DG_INLINE dgVector | operator| (const dgVector &data) const
DG_INLINE dgVector | operator^ (const dgVector &data) const
DG_INLINE dgVector | AndNot (const dgVector &data) const
DG_INLINE dgInt32 | GetSignMask () const
DG_INLINE dgVector | ShiftTripleRight () const
DG_INLINE dgVector | MoveLow (const dgVector &data) const
DG_INLINE dgVector | MoveHigh (const dgVector &data) const
DG_INLINE dgVector | PackLow (const dgVector &data) const
DG_INLINE dgVector | PackHigh (const dgVector &data) const

## Static Public Member Functions

static DG_INLINE void | Transpose4x4 (dgVector &dst0, dgVector &dst1, dgVector &dst2, dgVector &dst3, const dgVector &src0, const dgVector &src1, const dgVector &src2, const dgVector &src3)

## Public Attributes

union {
__m128 m_type
__m128i m_typeInt
dgFloat32 m_f [4]
struct {
dgFloat32 m_x
dgFloat32 m_y
dgFloat32 m_z
dgFloat32 m_w
} |
struct {
dgInt32 m_ix
dgInt32 m_iy
dgInt32 m_iz
dgInt32 m_iw
} |
}; |

## Static Public Attributes

static dgVector | m_one
static dgVector | m_wOne
static dgVector | m_two
static dgVector | m_half
static dgVector | m_three
static dgVector | m_negOne
static dgVector | m_signMask
static dgVector | m_triplexMask

## Constructor & Destructor Documentation

## § dgVector() [1/9]

DG_INLINE dgVector::dgVector | ( |  | ) |

inline

## § dgVector() [2/9]

DG_INLINE dgVector::dgVector | ( | const __m128 | type | ) |

inline

## § dgVector() [3/9]

DG_INLINE dgVector::dgVector | ( | const __m128i | type | ) |

inline

## § dgVector() [4/9]

DG_INLINE dgVector::dgVector | ( | const dgFloat32 | a | ) |

inline

## § dgVector() [5/9]

DG_INLINE dgVector::dgVector | ( | const dgFloat32 *const | ptr | ) |

inline

## § dgVector() [6/9]

DG_INLINE dgVector::dgVector | ( | const dgVector & | copy | ) |

inline

## § dgVector() [7/9]

DG_INLINE dgVector::dgVector | ( | const dgBigVector & | copy | ) |

inline

## § dgVector() [8/9]

DG_INLINE dgVector::dgVector | ( | dgFloat32 | x,
|  | dgFloat32 | y,
|  | dgFloat32 | z,
|  | dgFloat32 | w
| ) |  |

inline

## § dgVector() [9/9]

DG_INLINE dgVector::dgVector | ( | dgInt32 | ix,
|  | dgInt32 | iy,
|  | dgInt32 | iz,
|  | dgInt32 | iw
| ) |  |

inline

## Member Function Documentation

## § Abs()

DG_INLINE dgVector dgVector::Abs | ( |  | ) | const

inline

## § AddHorizontal()

DG_INLINE dgVector dgVector::AddHorizontal | ( |  | ) | const

inline

## § AndNot()

DG_INLINE dgVector dgVector::AndNot | ( | const dgVector & | data | ) | const

inline

## § BroadcastW()

DG_INLINE dgVector dgVector::BroadcastW | ( |  | ) | const

inline

## § BroadcastX()

DG_INLINE dgVector dgVector::BroadcastX | ( |  | ) | const

inline

## § BroadcastY()

DG_INLINE dgVector dgVector::BroadcastY | ( |  | ) | const

inline

## § BroadcastZ()

DG_INLINE dgVector dgVector::BroadcastZ | ( |  | ) | const

inline

## § CompProduct3()

DG_INLINE dgVector dgVector::CompProduct3 | ( | const dgVector & | A | ) | const

inline

## § CompProduct4()

DG_INLINE dgVector dgVector::CompProduct4 | ( | const dgVector & | A | ) | const

inline

## § CrossProduct4()

DG_INLINE dgVector dgVector::CrossProduct4 | ( | const dgVector & | A,
|  | const dgVector & | B
| ) |  | const

inline

## § DotProduct4()

DG_INLINE dgVector dgVector::DotProduct4 | ( | const dgVector & | A | ) | const

inline

## § Floor()

DG_INLINE dgVector dgVector::Floor | ( |  | ) | const

inline

## § GetInt()

DG_INLINE dgVector dgVector::GetInt | ( |  | ) | const

inline

## § GetMax()

dgVector dgVector::GetMax | ( | const dgVector & | data | ) | const

inline

## § GetMin()

dgVector dgVector::GetMin | ( | const dgVector & | data | ) | const

inline

## § GetScalar()

DG_INLINE dgFloat32 dgVector::GetScalar | ( |  | ) | const

inline

## § GetSignMask()

DG_INLINE dgInt32 dgVector::GetSignMask | ( |  | ) | const

inline

## § InvMagSqrt()

DG_INLINE dgVector dgVector::InvMagSqrt | ( |  | ) | const

inline

## § InvSqrt()

DG_INLINE dgVector dgVector::InvSqrt | ( |  | ) | const

inline

## § MoveHigh()

DG_INLINE dgVector dgVector::MoveHigh | ( | const dgVector & | data | ) | const

inline

## § MoveLow()

DG_INLINE dgVector dgVector::MoveLow | ( | const dgVector & | data | ) | const

inline

## § operator &()

DG_INLINE dgVector dgVector::operator& | ( | const dgVector & | data | ) | const

inline

## § operator%()

DG_INLINE dgFloat32 dgVector::operator% | ( | const dgVector & | A | ) | const

inline

## § operator*()

DG_INLINE dgVector dgVector::operator* | ( | const dgVector & | B | ) | const

inline

## § operator+()

DG_INLINE dgVector dgVector::operator+ | ( | const dgVector & | A | ) | const

inline

## § operator+=()

DG_INLINE dgVector& dgVector::operator+= | ( | const dgVector & | A | ) |

inline

## § operator-()

DG_INLINE dgVector dgVector::operator- | ( | const dgVector & | A | ) | const

inline

## § operator-=()

DG_INLINE dgVector& dgVector::operator-= | ( | const dgVector & | A | ) |

inline

## § operator<()

DG_INLINE dgVector dgVector::operator< | ( | const dgVector & | data | ) | const

inline

## § operator<=()

DG_INLINE dgVector dgVector::operator<= | ( | const dgVector & | data | ) | const

inline

## § operator==()

DG_INLINE dgVector dgVector::operator== | ( | const dgVector & | data | ) | const

inline

## § operator>()

DG_INLINE dgVector dgVector::operator> | ( | const dgVector & | data | ) | const

inline

## § operator>=()

DG_INLINE dgVector dgVector::operator>= | ( | const dgVector & | data | ) | const

inline

## § operator[]() [1/2]

DG_INLINE dgFloat32& dgVector::operator[] | ( | dgInt32 | i | ) |

inline

## § operator[]() [2/2]

DG_INLINE const dgFloat32& dgVector::operator[] | ( | dgInt32 | i | ) | const

inline

## § operator^()

DG_INLINE dgVector dgVector::operator^ | ( | const dgVector & | data | ) | const

inline

## § operator|()

DG_INLINE dgVector dgVector::operator| | ( | const dgVector & | data | ) | const

inline

## § PackHigh()

DG_INLINE dgVector dgVector::PackHigh | ( | const dgVector & | data | ) | const

inline

## § PackLow()

DG_INLINE dgVector dgVector::PackLow | ( | const dgVector & | data | ) | const

inline

## § Reciproc()

DG_INLINE dgVector dgVector::Reciproc | ( |  | ) | const

inline

## § Scale3()

DG_INLINE dgVector dgVector::Scale3 | ( | dgFloat32 | s | ) | const

inline

## § Scale4()

DG_INLINE dgVector dgVector::Scale4 | ( | dgFloat32 | s | ) | const

inline

## § ShiftTripleRight()

DG_INLINE dgVector dgVector::ShiftTripleRight | ( |  | ) | const

inline

## § Sqrt()

DG_INLINE dgVector dgVector::Sqrt | ( |  | ) | const

inline

## § Store()

DG_INLINE void dgVector::Store | ( | dgFloat32 *const | dst | ) | const

inline

## § TestZero()

DG_INLINE dgVector dgVector::TestZero | ( |  | ) | const

inline

## § Transpose4x4()

static DG_INLINE void dgVector::Transpose4x4 | ( | dgVector & | dst0,
|  | dgVector & | dst1,
|  | dgVector & | dst2,
|  | dgVector & | dst3,
|  | const dgVector & | src0,
|  | const dgVector & | src1,
|  | const dgVector & | src2,
|  | const dgVector & | src3
| ) |  |

inlinestatic

## Member Data Documentation

## § @10

union { ... }

## § m_f

dgFloat32 dgVector::m_f[4]

## § m_half

dgVector dgVector::m_half

static

## § m_iw

dgInt32 dgVector::m_iw

## § m_ix

dgInt32 dgVector::m_ix

## § m_iy

dgInt32 dgVector::m_iy

## § m_iz

dgInt32 dgVector::m_iz

## § m_negOne

dgVector dgVector::m_negOne

static

## § m_one

dgVector dgVector::m_one

static

## § m_signMask

dgVector dgVector::m_signMask

static

## § m_three

dgVector dgVector::m_three

static

## § m_triplexMask

dgVector dgVector::m_triplexMask

static

## § m_two

dgVector dgVector::m_two

static

## § m_type

__m128 dgVector::m_type

## § m_typeInt

__m128i dgVector::m_typeInt

## § m_w

dgFloat32 dgVector::m_w

## § m_wOne

dgVector dgVector::m_wOne

static

## § m_x

dgFloat32 dgVector::m_x

## § m_y

dgFloat32 dgVector::m_y

## § m_z

dgFloat32 dgVector::m_z

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/core/dgVector.h
- dynamics.mod/NewtonDynamics/source/core/dgMatrix.cpp